/*
  Compact a set of clauses by propagating the unit clauses.
*/

#include"list.h"
#include"queue.h"
#include"mindp.h"


int compact( setofclauses cl, setofclauses *rcl, int renaming, int **name ) {
  clauseindex ix;
  state stt;
  stack stk;

  int u;

  int newvar;

  int i,c;
  listofint l;


				/* allocate names */

  if( renaming ) {
    *name=(int *) malloc( (cl->numvar+1)*sizeof(int) );
    if( *name==NULL ) {
      printf("Malloc failed in compact().\n");
      exit(1);
    }
  }


				/* propagate unit clauses */

  initial( cl, &ix, &stt, &stk, 0 );

  u=propagateunitclauses( cl, ix, stt, stk, 0 );

  if( u!=0 ) {
    freeindex(ix);
    freestate(stt);
    freestack(stk);
    return u;
  }


				/* renaming of variables */

  if( renaming ) {
    newvar=0;
    for(i=1; i<=cl->numvar; i++)
      if( stt->val[i]==0 ) {
        newvar++;
        (*name)[i]=newvar;
      }
      else
        (*name)[i]=(stt->val[i]==1)?-1:-2;
  }


				/* create the new set of clauses */

  (*rcl)=newsetofclauses();
  initsetofclauses(rcl);

  for(c=0; c<cl->numclauses; c++)
    if( stt->truelits[c]==0 ) {
      for(l=cl->cl[c].lett; l!=NULL; l=l->next)
        if( stt->val[abs(l->elem)]==0 )
          if( !renaming )
            addliteral(l->elem,rcl);
          else
            addliteral( sgn(l->elem)*(*name)[abs(l->elem)], rcl );
      endclause(rcl);
    }


  freeindex(ix);
  freestack(stk);
  freestate(stt);

  return 0;
}



