#include"dp.h"

long int nummodels;


		/* given a (partial) model, counts the number of unassigned
		variables to determine the number of models */

int countmodels( state stt ) {
  int i,unass;

  unass=0;

  for( i=1; i<=stt->numvar; i++ )
    if( valueofvar( i, stt ) == 0 )
      unass++;

  #ifdef DEBUG
    printf("Unass=%d\n",unass);
  #endif

  nummodels += (1<<unass);
}
    

		/* MAIN */

main() {
  setofclauses cl;
  clauseindex ix;
  state stt;
  stack stk;
  int i;

		/* read set of clauses */

  cl=newsetofclauses();
  readclauses( stdin, &cl );


		/* no model yet */

  nummodels=0;


		/* first model (if any) */

  if( firstmodel( cl, &ix, &stt, &stk, DEFAULTDP && ~SIMPLIFY ) == -1 )
    #ifdef DEBUG
      printf("Inconsistent\n")
    #endif
    ;
  else {
    #ifdef DEBUG
    printf("Consistent\n");
    printf("Model:\n");

    for(i=1; i<=cl->numvar; i++) 
      printf("val(%d)=%2d  ",i,valueofvar( i, stt ) );
    printf("\n");
    #endif

    countmodels( stt );


		/* next models */

    while( nextmodel( cl, ix, stt, stk, DEFAULTDP ) != -1 ) {
      #ifdef DEBUG
      for(i=1; i<=7; i++) 
        printf("val(%d)=%2d  ",i,valueofvar( i, stt ) );
      printf("\n");
      #endif

      countmodels( stt );
    }
  }

  freeclauses(cl);

  printf("Number of models: %d\n",nummodels);

  return 0;
}

