/*
  This is the satifisbility client. It just sends a fixed set of clauses
to the satisfiability server. The address must be specified in the command
line (e.g. satclient localhost if server and client are running on the
same machine).

  Note that dp.h and libdp.a are not needed, as the set of clauses is
send as a sequences of lines to the satserver.
*/


#include<stdio.h>
#include<unistd.h>
#include<sys/types.h>
#include<sys/socket.h>
#include<netinet/in.h>
#include<netdb.h>
#include<fcntl.h>

				/* port */

#define PORT 9090


main( int argc, char *argv[] ) {
  int s;
  struct hostent *addr;
  struct sockaddr_in sa;		/* address */
  FILE *in, *out;
  char buf[5000];
  char c;


					/* check arguments */

  if( argc<2 ) {
    printf("Specify server address.\n");
    exit(1);
  }
  


					/* open socket */

  s=socket( AF_INET, SOCK_STREAM, 0 );
  if( s<0 ) {
    perror("Error in opening socket");
    exit(1);
  }


  					/* set address */

  addr=gethostbyname(argv[1]);
  if( addr==NULL ) {
    printf("Can't determine address of %s\n",argv[1]);
    perror("Gethostbyname");
    exit(1);
  }

  sa.sin_family=AF_INET;
  bcopy(addr->h_addr, &sa.sin_addr, addr->h_length);
  sa.sin_port=htons(PORT);


					/* connect */

  if( connect( s, (struct sockaddr *) &sa, sizeof(sa) )<0 ) {
    perror("Connecting");
    printf("Is satsocket running on %s?\n",argv[1]);
    exit(1);
  }


					/* open file descriptors */

  in=fdopen(s, "r");
  out=fdopen(s, "w");


					/* read header */

  printf("Reading header.\n");
  while(1) {
    fscanf(in,"%[^\n]s\n",buf);
    printf("%s\n",buf);

    if( buf[3]!='-' )
      break;

    fscanf(in,"%[\n]s",buf);
  }


					/* send clauses */

  printf("Sending clauses.\n");

  fprintf(out,"1 2 3 0\n");
  fprintf(out,"-1 0\n");
  fprintf(out,"-2 -3 0\n");
  fprintf(out,"%%\n");
  fflush(out);


					/* read result */

  fscanf(in,"%[\n]s",buf);
  do {
    if( fscanf(in,"%[^\n]s",buf)<1 )
      break;
    printf("%s\n",buf);
    fscanf(in,"%c",&c);
  } while( !feof(in) );


  return 0;
}
