#include<stdlib.h>
#include<stdio.h>
#include<time.h>
#include<getopt.h>
#include<sys/time.h>
#include<unistd.h>


#define abs(x)		(((x)>0)?(x):(-x))

/* insert acknowledgement to Massacci here */

/* insert Massacci's disclaimer here */

#define RAND_MAX  2147483647

void InitRandom()
{
  struct timeval tv;
  struct timezone tzp;
  long sec, msec;

  gettimeofday(&tv,&tzp);
  sec = (long) tv.tv_sec;
  msec = (long) tv.tv_usec;

  srandom((unsigned int)(((sec & 0177 ) * 1000000) + msec));
}

int Random1To(int n)
{
    return (1+(int)(((double)n)*random()/(1.0+RAND_MAX)));
}


				/* minimum between two integers */

int min(int x, int y ) {
  return (((x)<(y))?(x):(y));
}


				/* is x in clausola? */

int presente( int x, int size, int *clausola ) {
  int i,j;

  for(i=0; i<size; i++)
    if( abs(clausola[i])==abs(x) )
      return 0;

  return 1;
}


				/* random literal */

int randlit ( int numvar ) {
  int temp;

  /* temp=random()%(numvar<<1)+1; */
  temp=Random1To(2*numvar);
  if( temp>numvar ) temp=numvar-temp;

  return temp;
}


				/* print usage and exit */

int usage() {
  printf("Usage:\n   genera [-v] [-w] [-t type] numvar numclauses [skip]\n\n");
  printf("-v variable clause size\n");
  printf("-w weighted variables\n");
  printf("-t0 all variables have weight 1\n");
  printf("  1 variables have random weight in the interval [0-9]\n");
  printf("  2 50%% variables have weight 1\n");
  printf("  3 10%% variables have weight 1\n");
  printf("  4 all variables have weight 0\n");
  printf("  5 20%% variables have weight 1\n");
  exit(1);
}


				/* MAIN */

main( int argc, char* argv[] ) {
  int argx,argn;

  int numvar,numclausole;
  int cl,v;
  int i;

  int tipo=-1;
  int salto=-1;
  int varsize=0;
  int weighted=0;

  int size,x;
  int clausola[100];


						/* parse options */

  argn=0;
  while( optind<argc ) {
    argx=getopt( argc, argv, "-vwt:" );

    if( argx!=1 )
      switch( argx ) {
        case 't':	if( !isdigit(*optarg) ) usage();
  			tipo=atoi(optarg);
			weighted=1;
			break;
        case 'v':	varsize=1;
			break;
	case 'w':	weighted=1;
			break;
        default:	usage();
      }
    else {
      argn++;
      switch( argn ) {
        case 1:	numvar=atoi(optarg);
		break;
	case 2:	numclausole=atoi(optarg);
		break;
	case 3: salto=atoi(optarg);
		break;
	default: usage();
      }
    }
  }

  if( argn<2 )
    usage();


  printf("c type=%d skip=%d\n",tipo,salto); fflush(stdout);


						/* skip first formulas */

  for(i=0; i<salto*(numvar*numclausole+2); i++)
    random();

  printf("p cnf+w %d %d\n",numvar,numclausole); 

  if( salto==-1 )
    InitRandom();
    /* srandom(time(0)); */



						/* loop for each clause to be generated */

  for(cl=0; cl<numclausole; cl++) {


				/* clause lenght */

    if( !varsize ) 
      size=3;
    else {
      x=Random1To(6);
      if( x==0 )
        x=2;
      if( x<5 )
        size=min( numvar, x+1);
      else
        size=min( numvar, Random1To(15)+1 );
    }

    /* printf("size(%d) ",size); fflush(NULL); */


				/* generate literals */

    for(x=0; x<size; x++)
      do {
        clausola[x]=randlit(numvar);
      } while( ! presente( clausola[x], x, clausola ) );

    for(x=0; x<size; x++) 
      printf("%d ",clausola[x]);
    printf("0\n");

  }


				/* generate weights */

  if( weighted ) {
    if( tipo<0 )
      tipo=Random1To(4)-1;
  
    printf(":\n");
    for(v=1;v<=numvar;v++)
      switch( tipo ) {
        case 0:	printf("%d\n",1);		/* pesi tutti uguali a 1: modello minimo */
           	break;
        case 1:	printf("%d\n",Random1To(11)-1);	/* distribuzione uniforme pesi */
           	break;
        case 2:	printf("%d\n",Random1To(2)-1);	/* minimizzare meta' delle variabili */
           	break;
        case 3:	printf("%d\n",(Random1To(10)==1)); /* minimizzare 10% delle variabili */
           	break;
	case 4: printf("0\n");
		break;
	case 5: printf("%d\n",(Random1To(5)==1)); /* minimizza 20% */
		break;
        default:	printf("Unknown type\n");
  		break;
      }
  }

  printf("%%\n");

  return 0;
}
