/*
  Contiene le funzioni relative alle liste. Le
definizioni delle funzioni si trovano in list.h,
dove sono anche definiti i tipi.
*/


#include"list.h"

#define NEW(rec) (rec *) malloc (sizeof (rec))


/************************** List of Int **************************/


			/* cons su una lista di interi */

listofint conslistofint( listofint l, int i ) {
  listofint r;

  r=NEW(struct reclistofint);
  if( r==NULL ) {
    printf("Malloc failed in conslistofint()\n");
    exit(1);
  }
  r->elem=i;
  r->next=l;

  return r;
}



			/* reverse a list of int */

listofint reverselistofint( listofint l ) {
  listofint r,t;

  r=NULL;

  for(t=l; t!=NULL; t=t->next ) 
    r=conslistofint(r, t->elem);

  return r;
}


			/* free a list of int */

int freelistofint( listofint l ) {
  listofint l1;

  while( l!=NULL ) {
    l1=l->next;

    free(l);

    l=l1;
  }
}


			/* sort a list of int */

int sortlistofint( listofint index, listofint values, int comparison( int, int ) ) {
  int n, i;
  listofint sindex, svalues;
  int t;

  if( index==NULL )
    return 1;

  if( index->next==NULL )
    return 2;

  n=0;
  for(sindex=index; sindex!=NULL; sindex=sindex->next)
    n++;

  t=0;
  for(svalues=values; svalues!=NULL; svalues=svalues->next)
    t++;

  if( t!=n ) {
    printf("Attempt to sort lists of different lenght.\n");
    exit(1);
  }

  for(i=0; i<n; i++) {
    svalues=values;
    for(sindex=index; sindex->next!=NULL; sindex=sindex->next) {
      if( ! comparison( svalues->elem, (svalues->next)->elem ) ) {
        t=sindex->elem;
        sindex->elem=(sindex->next)->elem;
        (sindex->next)->elem=t;
     
        t=svalues->elem;
        svalues->elem=(svalues->next)->elem;
        (svalues->next)->elem=t;
      }
      svalues=svalues->next;
    }
  }

  return 0;
}


                        /* print a list of int */

int printlistofint( FILE *stream, listofint l ) {
  while( l!=NULL ) {
    fprintf(stream,"%d ",(*l).elem);
    l=l->next;
  }
}


