#include"global.h"
#include"formulae.h"

#include"dp.h"


				/* print a formula */

void printformula( formula f ) {
  int o,e;

  if( f==NULL )
   ;
  else {
    o=f->op;
    switch( o ) {
      case LIT: printf("%d",f->var);
		break;
      case NOT:	printf("-");
		printformula(f->destro);
		break;
      case AND: printf("(");
		printformula(f->sinistro);
		printf("&");
		printformula(f->destro);
		printf(")");	
		break;
      case OR:	printf("(");
		printformula(f->sinistro);     
		printf("v");
		printformula(f->destro);
		printf(")");
		break;
      default:  printf("Invalid formula\n");
		exit(1);
    }
  }
}


				/* convert a formula to a cnf */

setofclauses formulatocnf( formula fi, int numvar ) {
  setofclauses cl;
  int numformule;
  formula formule[200];
  int sign[200];
  int var[200];
  formula f;
  int auxvar;
  int s,v;
  int op;

  cl=newsetofclauses();
  initsetofclauses(&cl);

  numformule=1;
  formule[0]=fi;
  sign[0]=1;
  var[0]=numvar+1;

  auxvar=numvar+1;
  addliteral(auxvar,&cl);
  endclause(&cl);

  while( numformule > 0 ) {

    numformule--;
    f=formule[numformule];
    s=sign[numformule];
    v=var[numformule];

    if( f==NULL )
      continue;
 
    op=f->op;
    if( s<0 )
      if( op==AND )
        op=OR;
      else if( op==OR )
        op=AND;

    switch( op ) {
      case LIT:	addliteral(-v,&cl);
		addliteral(s*(f->var),&cl);
		endclause(&cl);
		break;

      case AND: addliteral(-v,&cl);
		auxvar++;
		addliteral(auxvar,&cl);
		endclause(&cl);
		formule[numformule]=f->sinistro;
		sign[numformule]=s;
		var[numformule]=auxvar;
		numformule++;

		addliteral(-v,&cl);
		auxvar++;
		addliteral(auxvar,&cl);
		endclause(&cl);
		formule[numformule]=f->destro;
		sign[numformule]=s;
		var[numformule]=auxvar;
		numformule++;
		
		break;

      case OR:	addliteral(-v,&cl);
		auxvar++;
		addliteral(auxvar,&cl);
		formule[numformule]=f->sinistro;
		sign[numformule]=s;
		var[numformule]=auxvar;
		numformule++;

		auxvar++;
		addliteral(auxvar,&cl);
		endclause(&cl);
		formule[numformule]=f->destro;
		sign[numformule]=s;
		var[numformule]=auxvar;
                numformule++;
	
		break;

      case NOT:	formule[numformule]=f->destro;
		sign[numformule]=-s;
		numformule++;
		break;

      default:  printf("Invalid formula\n");
		break;
    }

  }
    
  return cl;
}



main () {
  setofclauses cl;
  state stt;
  int i,s;

				/* parse input */

  yyparse();


				/* print the formula */

  printf("Formula after variable naming: ");
  printformula(f);
  printf("\n");


				/* convert to cnf */

  cl=formulatocnf(f,numvar);


				/* print clauses */

  printf("Formula converted to a set of clauses.\n");
  printclauses(cl);


				/* find one model (if any) */

  s=onemodel(cl,&stt,DEFAULTDP);


				/* print result */

  if( s<0 )
    printf("Inconsistent\n");
  else {
    printf("Consistent\n");

    printf("Model: ");

    for(i=1; i<=numvar; i++)
      if( valueofvar(i,stt)>0 )
        printf("%s ",varname[i]);
      else
        printf("-%s ",varname[i]);

    printf("\n");
  }

  return 0;
}
