%option noyywrap

%{
#include<stdlib.h>
#include"global.h"
#include"formulae.h"
#include"syntax.tab.h"

#define ECHO ;

int addvariable( char *id ) {
  int i;

  for(i=1; i<=numvar; i++)
    if( strcmp( id, varname[i] ) == 0 )
      return i;

  numvar++;

  varname[numvar]=(char *) malloc( strlen(id) );
  strcpy( varname[numvar], id );

  return numvar;
}

%}

%x COMM
%x LINECOMM

%%
[a-zA-Z0-9_]+	{ ECHO; yylval.val=addvariable(yytext); return NUM; }
\/\*		{ BEGIN(COMM); }
\/\/		{ BEGIN(LINECOMM); }
" "+    	{ }
\t|\n   	{ }
.       	{ ECHO; return *yytext; }


<COMM>\*\/      { BEGIN(INITIAL); }
<COMM>.         { }
<COMM>\n        { }

<LINECOMM>.     { }
<LINECOMM>\n    { BEGIN(INITIAL); }

%%

