/*
  Funzioni e procedure che implementano
una coda di interi.
*/

#include"queue.h"

#define NEW(rec) (rec *) malloc (sizeof (rec))


			/* test if the queue is empty */

int isempty( queue *q ) {
  return ( q->in==q->out );
}


			/* insert an element in the queue */

void inqueue( queue *q, int x ) {
  q->in++;
  q->in=q->in%MAXQUEUE;

  if( q->in==q->out ) {
    printf("Queue full.\n");
    exit(1);
  }

  q->elem[q->in]=x;
}


			/* remove an element from the queue */

int outqueue( queue *q ) {
  int x;

  if( q->out==q->in ) {
    printf("Queue empty.\n");
    exit(1);
  }

  q->out++;
  q->out=q->out%MAXQUEUE;

  return q->elem[q->out];
}


			/* next element of the queue */

int topqueue( queue *q ) {
  if( q->out==q->in ) {
    printf("Queue empty.\n");
    exit(1);
  }

  return q->elem[(q->out+1)%MAXQUEUE];
}


			/* init a queue (includ. memory allocation) */

queue *emptyqueue() {
  queue *q;

  q=NEW(queue);

  q->in=0;
  q->out=0;

  return q;
}


			/* remove all elements from an alrady allocated queue */

int rmallqueue( queue *q ) {
  if( q==NULL ) {
    printf("Cannot remove all elements from an empty queue\n");
    exit(1);
  }

  q->in=0;
  q->out=0;

  return 0;
}


			/* print all elements of a queue */

int printqueue( queue *q ) {
  int i;

  printf("(%d,%d): ",q->out,q->in);

  printf("[ ");
  for(i=(q->out+1)%MAXQUEUE; i!=(q->in+1)%MAXQUEUE; i=(i+1)%MAXQUEUE)
    printf("%d ",q->elem[i]);
  printf("]\n");

  return 0;
}
