#include<stdio.h>

#define MAXTIME 300
#define FIRSTCLAUSES 1
#define MAXCLAUSES 500
#define MAXPUNTI 500

int table[MAXTIME+1][MAXCLAUSES+1];
int media[MAXCLAUSES+1];
int punti[MAXPUNTI];

main ( int argc, char* argv[] ) {
  FILE* input;
  FILE* output;

  char filename[200];

  int clauses,time;

  int oldclauses,numpunti;
  int i,s;

  int color;


		/* riempe la matrice di zeri */

  memset( table, 0, (MAXTIME+1)*(MAXCLAUSES+1)*sizeof(int) );


		/* numero argomenti */

  if( argc<1 ) {
    printf("Manca il nome del file\n");
    exit(1);
  }

  strcpy(filename,argv[1]);


		/* lettura file */

  input=fopen( filename , "r" );
  oldclauses=FIRSTCLAUSES;
  numpunti=1;

  while( !feof(input) ) {
    fscanf(input,"%d %d\n",&clauses,&time);

    if( time<MAXTIME )
      table[time][clauses]=1;

    if( clauses==oldclauses ) {
      punti[numpunti]=time;
      numpunti++;
    }
    else {
      s=0;
      for(i=0; i<numpunti; i++)
        s+=punti[i];

      media[oldclauses]=s/numpunti;

      oldclauses=clauses;
      numpunti=1;
    }
  }

  fclose(input);


		/* scrittura file */

  strcat(filename,".ppm");
  output=fopen( filename , "w" );

  fprintf(output,"P3\n");
  fprintf(output,"%d\n%d\n",MAXCLAUSES+1,MAXTIME+1);
  fprintf(output,"15\n");

  for(time=0; time<=MAXTIME; time++)
    for(clauses=0; clauses<=MAXCLAUSES; clauses++) {
      color=0;

      if( ( time==MAXTIME ) || ( clauses==0 ) )
        color=1;
      if( table[MAXTIME-time][clauses] )
        color=2;
      if( media[clauses]==(MAXTIME-time) )
        color=3;

      switch( color ) {
        case 0: fprintf(output,"15 15 15\n");
                break;
        case 1: fprintf(output,"0 0 0\n");
                break;
        case 2: fprintf(output,"0 15 0\n");
                break;
        case 3: fprintf(output,"15 0 0\n");
                break;
      }
    }
      

  fclose(output);


  return 0;
}



